/* Sistemas Integrados TECNISA
   Servios

Nome: NRHORAS_EVOLCONT

Descrio:
Retorna a mdia de intervalo de horas entre as evolues do contato.

Criao:
05/04/2001 Ederson Melquades da Cunha
*/

CREATE OR REPLACE
FUNCTION NRHORAS_EVOLCONT
  (P_CDFILIAL  IN VARCHAR2,
   P_NRCONTATO IN VARCHAR2) RETURN NUMBER IS

   V_NRHORAS NUMBER;

BEGIN

   SELECT
      AVG((DTHR_EVOLUCAO - DTHR_ANTERIOR)*24)
   INTO
      V_NRHORAS
   FROM
      (SELECT
          EVOL_A.CDFILIAL,
          EVOL_A.NRCONTATO,
          EVOL_A.DTHREVOLCONT AS DTHR_EVOLUCAO,
          EVOL_B.DTHREVOLCONT AS DTHR_ANTERIOR
       FROM
          (SELECT CDFILIAL, NRCONTATO, DTHREVOLCONT, IDSENEVOCONT FROM EVOLCONT WHERE CDFILIAL = P_CDFILIAL AND NRCONTATO = P_NRCONTATO) EVOL_A,
          (SELECT CDFILIAL, NRCONTATO, DTHREVOLCONT, IDSENEVOCONT FROM EVOLCONT WHERE CDFILIAL = P_CDFILIAL AND NRCONTATO = P_NRCONTATO) EVOL_B
       WHERE
          EVOL_B.DTHREVOLCONT = (SELECT MAX(DTHREVOLCONT) FROM EVOLCONT
                                 WHERE CDFILIAL = P_CDFILIAL AND NRCONTATO = P_NRCONTATO AND DTHREVOLCONT < EVOL_A.DTHREVOLCONT) AND
          EVOL_A.CDFILIAL     = EVOL_B.CDFILIAL  AND
          EVOL_A.NRCONTATO    = EVOL_B.NRCONTATO AND
          EVOL_A.CDFILIAL     = P_CDFILIAL       AND
          EVOL_A.NRCONTATO    = P_NRCONTATO      AND
          EVOL_A.IDSENEVOCONT||EVOL_B.IDSENEVOCONT IN ('SE','SS')
       )
    GROUP BY
       CDFILIAL,
       NRCONTATO;

   RETURN(V_NRHORAS);
END;
/
